HalDeviceStore
3
HAL Library

# HalDeviceStore

## Synopsis

                HalDeviceStore;
    void        (*HalDeviceStoreAsyncCallback)  (HalDeviceStore *store,
                                                 HalDevice *device,
                                                 gpointer user_data);
    gboolean    (*HalDeviceStoreForeachFn)      (HalDeviceStore *store,
                                                 HalDevice *device,
                                                 gpointer user_data);
    HalDeviceStore* hal_device_store_new        (void);
    void        hal_device_store_add            (HalDeviceStore *store,
                                                 HalDevice *device);
    gboolean    hal_device_store_remove         (HalDeviceStore *store,
                                                 HalDevice *device);
    HalDevice*  hal_device_store_find           (HalDeviceStore *store,
                                                 const char *udi);
    void        hal_device_store_foreach        (HalDeviceStore *store,
                                                 HalDeviceStoreForeachFn callback,
                                                 gpointer user_data);
    HalDevice*  hal_device_store_match_key_value_string
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value);
    HalDevice*  hal_device_store_match_key_value_int
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 int value);
    GSList*     hal_device_store_match_multiple_key_value_string
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value);
    void        hal_device_store_match_key_value_string_async
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value,
                                                 HalDeviceStoreAsyncCallback callback,
                                                 gpointer user_data,
                                                 int timeout);
    void        hal_device_store_print          (HalDeviceStore *store);

## Description

## Details

### HalDeviceStore

    typedef struct {
    	GObject parent;

    	GSList *devices;
    } HalDeviceStore;

### HalDeviceStoreAsyncCallback ()

    void        (*HalDeviceStoreAsyncCallback)  (HalDeviceStore *store,
                                                 HalDevice *device,
                                                 gpointer user_data);

`store` :

`device` :

`user_data` :

### HalDeviceStoreForeachFn ()

    gboolean    (*HalDeviceStoreForeachFn)      (HalDeviceStore *store,
                                                 HalDevice *device,
                                                 gpointer user_data);

`store` :

`device` :

`user_data` :

Returns :

### hal_device_store_new ()

    HalDeviceStore* hal_device_store_new        (void);

Returns :

### hal_device_store_add ()

    void        hal_device_store_add            (HalDeviceStore *store,
                                                 HalDevice *device);

`store` :

`device` :

### hal_device_store_remove ()

    gboolean    hal_device_store_remove         (HalDeviceStore *store,
                                                 HalDevice *device);

`store` :

`device` :

Returns :

### hal_device_store_find ()

    HalDevice*  hal_device_store_find           (HalDeviceStore *store,
                                                 const char *udi);

`store` :

`udi` :

Returns :

### hal_device_store_foreach ()

    void        hal_device_store_foreach        (HalDeviceStore *store,
                                                 HalDeviceStoreForeachFn callback,
                                                 gpointer user_data);

`store` :

`callback` :

`user_data` :

### hal_device_store_match_key_value_string ()

    HalDevice*  hal_device_store_match_key_value_string
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value);

`store` :

`key` :

`value` :

Returns :

### hal_device_store_match_key_value_int ()

    HalDevice*  hal_device_store_match_key_value_int
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 int value);

`store` :

`key` :

`value` :

Returns :

### hal_device_store_match_multiple_key_value_string ()

    GSList*     hal_device_store_match_multiple_key_value_string
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value);

`store` :

`key` :

`value` :

Returns :

### hal_device_store_match_key_value_string_async ()

    void        hal_device_store_match_key_value_string_async
                                                (HalDeviceStore *store,
                                                 const char *key,
                                                 const char *value,
                                                 HalDeviceStoreAsyncCallback callback,
                                                 gpointer user_data,
                                                 int timeout);

`store` :

`key` :

`value` :

`callback` :

`user_data` :

`timeout` :

### hal_device_store_print ()

    void        hal_device_store_print          (HalDeviceStore *store);

`store` :